#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MAXN = 1e5+5;
const int LOG = 17;


int n, q;
vector<int> g[MAXN];
int P[MAXN];
vector<array<int,3>> q1[MAXN]; //[0] koji je drugi cvor [1] koja je vrednost [2] koje je vreme
vector<array<int,3>> q2[MAXN]; //[0] koja je dubina [1] koja je vrednost [2] koje je vreme
int d[MAXN];
int up[MAXN][LOG];


int ans[MAXN];
void dfs(int x, int p){
    up[x][0] = p;
    for(int i = 1; i < LOG; ++i){
        up[x][i] = up[up[x][i-1]][i-1];
    }
    for(int k : g[x]){
        if(k==p) continue;
        d[k] = d[x]+1;
        dfs(k,x);
    }
}
int lift(int x, int k){
    int m = 0;
    while(k){
        if(k&1) x = up[x][m];
        ++m;
        k >>= 1;
    }
    return x;
}
int lca(int x, int y){
    if(d[x] < d[y]) swap(x, y);
    x = lift(x, d[x]-d[y]);
    if(x==y) return x;
    for(int i = LOG-1; i >= 0; --i){
        if(up[x][i]!=up[y][i]){
            x = up[x][i];
            y = up[y][i];
        }
    }
    return up[x][0];
}

int f[MAXN];
void add(int x, int y){
    for(int i = x; i < MAXN; i |= i+1) f[i] += y;
}
int sum(int x){
    int r = 0;
    for(int i = x; i >= 0; i = (i&i+1)-1) r += f[i];
    return r;
}
int get(int x){
    /*int l = 1, r = MAXN-1, ans = -1;
    while(l <= r){
        int m = (l+r)/2;
        if(sum(m) < x) l = m+1;
        else{
            ans = m;
            r = m-1;
        }
    }
    return ans;*/
    int ans = -1, s = 0, o = 0;
    for(int i = LOG-1; i >= 0; --i){
        if(o+(1<<i)-1 >= MAXN) continue;
        if(s + f[o+(1<<i)-1] >= x){
            ans = o+(1<<i)-1;
        }
        else{
            s += f[o+(1<<i)-1];
            o += (1<<i);
        }
    }
    return ans;
}

set<array<int,2>> dp[MAXN];
void dfs2(int x, int p){
    for(auto p : q2[x]){
        dp[p[0]].insert({p[1],p[2]});
    }
    for(int k : g[x]){
        if(k==p) continue;
        dfs2(k,x);
    }
    for(auto p : dp[d[x]]){
        add(p[1], p[0]);
    }
    /*ans[x] = get(P[x]);
    for(auto p : dp[d[x]]){
        add(p[1], -p[0]);
    }*/
    for(auto p : q2[x]){
        dp[p[0]].erase({p[1],p[2]});
    }
}

void solve(){
    cin >> n >> q;
    for(int i = 1; i < n; ++i){
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(1,1);
    int tt = 1;
    while(q--){
        int t, x, y, w;
        cin >> t >> x >> y >> w;
        if(t==1){
            int z = lca(x, y);
            q1[x].push_back({z,w,tt});
            q1[y].push_back({z,w,tt});
            q1[z].push_back({z,-w,tt});

        }
        else{
            q2[x].push_back({d[x]+y,w,tt});
        }
        ++tt;
    }
    for(int i = 1; i <= n; ++i){
        cin >> P[i];
    }
    dfs2(1,1);
    for(int i = 1; i <= n; ++i){
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int32_t main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int qqq=1;
    //cin>>qqq;
    while(qqq--) solve();
    return 0;
}