#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
using ll = long long;
#define pb push_back

const int N = 1e6 + 5, LOG = 18; // nzm
int XX;
struct segtree {
    vector<ll> st, lz;
    int n;
    void init(int _n) {
        if (_n != n) {
            st.resize(4*_n+10, 0);
            lz.resize(4*_n+10, 0);
            n = _n;
        }
        else {
            fill(st.begin(), st.end(), 0);
            fill(lz.begin(), lz.end(), 0);
        }
    }
    void push(int i, int l2, int r2) {
        if (lz[i]) {
            int m2 = (l2 + r2)/2;
            st[2*i] += (m2 - l2 + 1) * lz[i];
            st[2*i+1] += (r2 - m2) * lz[i];
            lz[2*i] += lz[i], lz[2*i+1] += lz[i];
            lz[i] = 0;
        }
    }
    void upd(int l, int r, ll x, int i, int l2, int r2) {
        if (l <= l2 && r2 <= r) {
            st[i] += x * (r2 - l2 + 1), lz[i] += x;
            return;
        }
        push(i, l2, r2);
        int m2 = (l2 + r2)/2;
        if (l <= m2)    upd(l, r, x, 2*i, l2, m2);
        if (m2+1 <= r)  upd(l, r, x, 2*i+1, m2+1, r2);
        st[i] = st[2*i] + st[2*i+1];
    }
    void upd(int l, int r, int x) {
        upd(l, r, x, 1, 1, n);
    }
    ll sum(int l, int r, int i, int l2, int r2) {
        if (l <= l2 && r2 <= r) return st[i];
        push(i, l2, r2);
        int m2 = (l2 + r2)/2;
        ll S = 0;
        if (l <= m2)    S += sum(l, r, 2*i, l2, m2);
        if (m2+1 <= r)  S += sum(l, r, 2*i+1, m2+1, r2);
        return S;
    }
    ll sum(int l, int r) {
        return sum(l, r, 1, 1, n);
    }
} T[N], A;
vector<int> g[N], lvl[N];
int tin[N], tout[N], up[LOG][N], D[N], TM = 0;
void dfs(int s, int e = -1) {
    tin[s] = ++TM;
    lvl[D[s]].pb(s);
    for (auto u : g[s]) {
        if (u == e) continue;
        cout << u << ' ' << s << endl;
        up[0][u] = s, D[u] = D[s] + 1;
        dfs(u, s);
    }
    tout[s] = TM;
}
int jump(int u, int k) {
    for (int i = 0; i < LOG; ++i) {
        if ((k >> i) & 1)   u = up[i][u];
    }
    return u;
}
int lca(int u, int v) {
    if (D[u] < D[v])    swap(u, v);
    u = jump(u, D[u] - D[v]);
    if (u == v) return u;
    for (int i = LOG-1; i >= 0; --i) {
        if (up[i][u] != up[i][v])   u = up[i][u], v = up[i][v];
    }
    return up[0][u];
}
mt19937 rng(time(0));
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q; // NE ZABORAVI DA ODKOMENTARISES
    for (int i = 0; i <= n; ++i)    lvl[i].pb(0);
    vector<array<int, 4>> qu(q+1); qu[0] = {0, 0, 0, 0};
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].pb(v); g[v].pb(u);
    }
    for (int i = 1; i <= q; ++i) {
        cin >> qu[i][0] >> qu[i][1] >> qu[i][2] >> qu[i][3];
    }
    ll p[n+1];
    for (int i = 1; i <= n; ++i)    cin >> p[i];
    dfs(1);
    for (int i = 0; i < n; ++i)    T[i].init(lvl[i].size());
    for (int i = 1; i < LOG; ++i) {
        for (int j = 1; j <= n; ++j)    up[i][j] = up[i-1][up[i-1][j]];
    }
    int L[n+1], R[n+1], ans[n+1], f[n+1];
    fill(L+1, L+n+1, 1);
    fill(R+1, R+n+1, q);
    fill(ans+1, ans+n+1, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < lvl[i].size(); ++j) {
            f[lvl[i][j]] = j;
        }
    }
    for (int _ = 0; _ < 20; ++_) {
        vector<int> B[q+1];
        for (int i = 1; i <= n; ++i)    T[i].init(lvl[i].size());
        A.init(n);
        for (int i = 1; i <= n; ++i) {
            if (L[i] <= R[i])   B[(L[i] + R[i]) / 2].pb(i);
        }
        for (int i = 1; i <= q; ++i) {
            if (qu[i][0] == 1) {
                A.upd(tin[qu[i][1]], tin[qu[i][1]], qu[i][3]);
                A.upd(tin[qu[i][2]], tin[qu[i][2]],  qu[i][3]);
                A.upd(tin[lca(qu[i][1], qu[i][2])], tin[lca(qu[i][1], qu[i][2])], -qu[i][3]);
                if (up[0][lca(qu[i][1], qu[i][2])]) {
                    A.upd(tin[up[0][lca(qu[i][1], qu[i][2])]], tin[up[0][lca(qu[i][1], qu[i][2])]], -qu[i][3]);
                }
            }
            else {
                int dep = D[qu[i][1]] + qu[i][2];
                int l = 1, r = lvl[dep].size() - 1, L = 1, R = 1;
                int u = qu[i][1];
                while (l <= r) {
                    int m = (l + r)/2;
                    if (tin[lvl[dep][m]] >= tin[u]) r = m-1, L = m;
                    else
                        l = m+1;
                }
                l = 1, r = lvl[dep].size() - 1;
                while (l <= r) {
                    int m = (l + r)/2;
                    if (tin[lvl[dep][m]] <= tout[u]) l = m+1, R = m;
                    else
                        r = m-1;
                }
                T[dep].upd(L, R, qu[i][3]);
            }
            for (auto j : B[i]) {
                if (T[D[j]].sum(f[j], f[j]) + A.sum(tin[j], tout[j]) >= p[j]) {
                    R[j] = i-1, ans[j] = i;
                }
                else {
                    L[j] = i+1;
                }
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        cout << ans[i] << ' ';
    }
    return 0;
}