#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long;
#define endl "\n";

vector<vector<int>> v1;
vector<vector<int>> v2;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    int n, m, k, ans=0;
    const int INF=1e9;
    int a, b;
    cin >> n >> m >> k;

    // stvaranje grafova
    v1.assign(n, vector<int>(n, false));
    v2.assign(n, vector<int>(n, false));
    for(int i=0; i<m; i++){
        cin >> a >> b;
        a--;
        b--;
        v1[a][b]=true;
        v1[b][a]=true;
    }
    for(int i=0; i<k; i++){
        cin >> a >> b;
        a--;
        b--;
        v2[a][b]=true;
        v2[b][a]=true;
    }

    /*for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            cout << v1[i][j] << ' ';
        }
        cout << endl;
    }
    cout << endl;
    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            cout << v2[i][j] << ' ';
        }
        cout << endl;
    }
    cout << endl;*/

    //pronalazenje missing edges
    vector<int> brNed(n, 0);
    int ukNed=0;
    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            if(v1[i][j]!=v2[i][j]){
                ukNed++;
                brNed[i]++;
                brNed[j]++;
            }
        }
    }
    for(int i=0; i<n; i++){
        brNed[i]/=2;
    }
    //int fs=20;
    while(ukNed){
        //fs--;
        //trazimo gde ima najvise gresaka
        int trMax=0;
        int maxInd=0;
        for(int i=0; i<n; i++){
            if(brNed[i]>trMax){
                trMax=brNed[i];
                maxInd=i;
            }
        }
        if(trMax==0){
            cout << ans;
            return 0;
        }
        /*for(int i=0; i<n; i++){
            for(int j=0; j<n; j++){
                cout << v1[i][j] << " ";
            }
            cout << endl;
        }
        cout << endl;
        for(int i=0; i<n; i++){
            for(int j=0; j<n; j++){
                cout << v2[i][j] << " ";
            }
            cout << endl;
        }
        cout << endl;
        cout << maxInd << endl;*/
        for(int i=0; i<n; i++){
            if(v1[i][maxInd]!=v2[i][maxInd]){
                v1[i][maxInd]=v2[i][maxInd];
                v1[maxInd][i]=v2[maxInd][i];
                brNed[i]--;
                brNed[maxInd]--;
                ukNed--;
            }
        }
        ans++;
        /*if(!fs){
            return 0;
        }*/
    }
    cout << ans;
    /*for(int i=0; i<n; i++){
        cout << i+1 << ": " << brNed[i] << endl;
    }
    cout << ukNed << endl;*/
}