#include<bits/stdc++.h>
using namespace std;

const int N=1e3+2;
int a[N][N],b[N][N],n;
int memo[N][2],cnt;

int get(int x,int ok){
    if(memo[x][ok]!=-1)return memo[x][ok];
    int ret=0;
    for(int i=0;i<x;++i)
        if((a[i][x]^ok)!=b[i][x])ret+=get(i,1);
    return(memo[x][ok]=ret+ok);
}

int lik[N],col[N],vis[N];

vector<int>g[N];
vector<int>comps[N];
int sz[N];

void dfs(int u){
    vis[u]=1;
    comps[cnt].push_back(u);
    sz[cnt]++;
    for(int v:g[u]){
        if(vis[v])continue;
        dfs(v);
    }
}

int probaj(int poc,int fi,vector<int>v){
    col[poc]=fi;
    queue<int>q;
    q.push(poc);
    while(!q.empty()){
        int u=q.front();
        q.pop();
        //cout<<u<<' '<<col[u]<<'\n';
        for(int v:g[u]){
            if(col[v]!=-1)continue;
            col[v]=col[u]^1;
            q.push(v);
        }
    }
    //cout<<'\n';
    int ret=0;
    for(auto&x:v)
        if(col[x]==1)++ret;
    return ret;
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int m,k;
    cin>>n>>m>>k;

    for(int i=0;i<m;++i){
        int u,v;
        cin>>u>>v;
        --u,--v;
        a[u][v]=1;
        a[v][u]=1;
    }

    for(int i=0;i<k;++i){
        int u,v;
        cin>>u>>v;
        --u,--v;
        b[u][v]=1;
        b[v][u]=1;
    }

    if(0){
        for(int i=0;i<n;++i)
            memo[i][0]=memo[i][1]=-1;

        for(int i=0;i<n;++i){
            get(i,0);
            get(i,1);
        }

        cout<<min(memo[n-1][0],memo[n-1][1]);
    }

    //cout<<"A"<<endl<<endl;
    for(int i=0;i<n;++i){
        for(int j=i+1;j<n;++j){
            if(a[i][j]!=b[i][j]){
                //cout<<i<<' '<<j<<'\n';
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    //cout<<"B"<<endl<<endl;

    //novi zadatak: dat je graf sa malo cvorova i dosta ivica
    //u jednom potezu mozes da obrises cvor i sve edgove koje su povezivale njega za nekog
    //u koliko najmenje poteza mozes da obrises sve ivice?

    for(int i=0;i<n;++i){
        if(!vis[i]){dfs(i);++cnt;}
    }

    for(int i=0;i<N;++i)
        col[i]=-1;

    int ans=0;
    for(int i=0;i<cnt;++i){
        if(sz[i]==1){
            continue;
        }
        int cur=1e18;
        //cout<<i<<' '<<sz[i]<<'\n';
        cur=min(cur,probaj(comps[i][0],0,comps[i]));
        for(auto&x:comps[i])col[x]=-1;
        cur=min(cur,probaj(comps[i][0],1,comps[i]));
        for(auto&x:comps[i])col[x]=-1;
        ans+=cur;
    }

    cout<<ans;
}