#include<bits/stdc++.h>
using namespace std;
using ll=long long;

const int N=1e6+4;
ll a[N],b[N],n,s;

ll probaj(ll x){
    ll ret=0,ocu=s/x;
    if(x>=n){
        ret+=(x-n)*ocu;
        for(int i=0;i<n;++i)
            ret+=abs(a[i]-ocu);
        ret/=2;
    }else{
        //radim sliding window
        //neka je trenutno br = suma razlika od ocu ljudi koji su visi od ocu
        //i neka je trenutno sum = suma u sliding windowu
        //onda je broj poteza = (s-sum) + br?

        ret=1e18;
        ll br=0,sum=0;
        for(int i=0;i<x;++i){
            sum+=a[i];
            if(a[i]>ocu)br+=a[i]-ocu;
        }

        //cout<<ret<<'\n';
        ret=min(ret,(s-sum)+br);
        //cout<<ret<<'\n';

        for(int i=1;i<=n-x;++i){
            if(a[i+x-1]>ocu)br+=a[i]-ocu;
            if(a[i-1]>ocu)br-=a[i-1]-ocu;
            sum+=a[i+x-1];
            sum-=a[i-1];
            //cout<<i<<' '<<sum<<' '<<br<<' '<<s-sum<<'\n';
            ret=min(ret,(s-sum)+br);
        }
//cout<<ret<<'\n';
    }
    //cout<<x<<' '<<ret<<'\n';
    return ret;
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin>>n;
    for(int i=0;i<n;++i){
        cin>>a[i];
        b[i]=a[i];
        s+=a[i];
    }

    sort(a,a+n);

    if(a[0]==a[n-1]){
        cout<<0;
        return 0;
    }

    ll ans=1e18;
    for(ll x=1;x<=s;++x){
        if(s%x)continue;
        if(x*x==s)ans=min(ans,probaj(x));
        else{
            ans=min(ans,probaj(x));
            ans=min(ans,probaj(s/x));
        }
    }

    cout<<ans;
}