#include <bits/stdc++.h>

using namespace std;

vector<int> bfs(int beginNode, vector<vector<int>> &graph) {
    queue<int> red;
    vector<int> poseceni, d(graph.size());

    red.emplace(beginNode);
    int iter = 1;
    while (red.size() > 0) {
        int currentNode = red.front();

        for (int newnode : graph[currentNode]) {
            red.emplace(newnode);
            if (d[newnode] == 0) d[newnode] = iter;
        }

        poseceni.push_back(currentNode);
        red.pop();

        iter++;
    }

    return d;

}

vector<int> distNodes(int beginNode, int dist, vector<vector<int>> &graph) {
    queue<int> red;
    vector<int> poseceni, result;

    red.emplace(beginNode);
    int iter = 1;
    while (red.size() > 0) {
        int currentNode = red.front();

        for (int newnode : graph[currentNode]) {
            red.emplace(newnode);
            if (iter == dist) {
                result.push_back(newnode);
            }
            // if (d[newnode] == 0) d[newnode] = iter;
        }


        poseceni.push_back(currentNode);
        red.pop();

        if (iter == dist) {
            return result;
        }

        // cout << red.size() << endl;

        iter++;
    }

    return result;

}

struct Operacija {
    int t, u, vd, x;
};

int main() {

    int n, q; cin >> n >> q;
    vector<vector<int>> graph(n - 1);
    vector<int> vrednosti(n);
    vector<Operacija> operacije(n);
    for (int i = 0; i < n - 1; i++) {
        vector<int> row;
        graph[i] = row;
    }

    for (int i = 0; i < n - 1; i++) {
        int a, b; cin >> a >> b;
        graph[min(a,b) - 1].push_back(max(a,b) - 1);
    }

    for (int i = 0; i < q; i++) {
        int t, u, vd, x; cin >> operacije[i].t >> operacije[i].u >> operacije[i].vd >> operacije[i].x;
    }

    vector<int> result(n), odgovori(n);
    for (int i = 0; i < n; i++) {
        cin >> result[i];
        odgovori[i] = -1;
    }

    int iter = 1;
    for (auto operacija : operacije) {
        if (operacija.t == 2) {
            vector<int> nodes = distNodes(operacija.u - 1, operacija.vd, graph);
            for (auto node : nodes) {
                vrednosti[node] += operacija.x;

                if (vrednosti[node] > result[node] && odgovori[node] == -1) {
                    odgovori[node] = iter;

                }
            }
        }
        else if (operacija.t == 1) {
            // bruh, nothing
        }

        iter++;
    }

    // cout << "\n";

    for (auto i : odgovori) {
        cout << i << " ";
    }
    cout << "\n";

    // cout << red.size() << endl;

    return 0;
}